#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>

typedef NS_ENUM(NSInteger, RapidPriority) {
    RapidPriorityLow,
    RapidPriorityNormal,
    RapidPriorityHigh
};

typedef NS_ENUM(NSInteger, RapidCacheControl) {
    RapidCacheControlImmutable,
    RapidCacheControlWeb,
    RapidCacheControlCacheOnly
};

// Object containing an image uri and metadata.
@interface RapidImageSource : NSObject

// uri for image, or base64
@property (nonatomic) NSURL* url;
// priority for image request
@property (nonatomic) RapidPriority priority;
// headers for the image request
@property (nonatomic) NSDictionary *headers;
// cache control mode
@property (nonatomic) RapidCacheControl cacheControl;

- (instancetype)initWithURL:(NSURL *)url
                   priority:(RapidPriority)priority
                    headers:(NSDictionary *)headers
               cacheControl:(RapidCacheControl)cacheControl;

@end
